<?php

//------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//	 	MISC FUNCTIONS
//		Version 1.0
//		Author: Perecedero
//		Company: Infinimedia Inc
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	function pressbackup_addFolderToZip($dir, $zipArchive)
	{
		if (is_dir($dir) && $dh = opendir($dir))
		{
			// Loop through all the files
			while (($file = readdir($dh)) !== false)
			{
				//If it's a folder, run the function again!
				if(!is_file($dir . $file))
				{
					//TODO verificar si esta vacio el folder y agregar el folder vacio.

					// Skip parent and root directories
					if( ($file !== '.') && ($file !== '..'))
					{
						if(!pressbackup_addFolderToZip($dir . $file . DIRECTORY_SEPARATOR, $zipArchive)){
							return false;
						}
					}
				}
				else
				{
					// Add the files
					if(!$zipArchive->addFile($dir . $file))
					{
						return false;
					}
				}
			}
		}else{
			return false;
		}
		return true;
	}

	function pressbackup_recursive_perform_actionFolder($str, $option)
	{
		if(is_file($str))
		{
			if($option['function']=='del')
			{
				return @unlink($str);
			}
			elseif($option['function']=='chmod')
			{
				return @chmod($str, $option['param'][0]);
			}
		}
		elseif(is_dir($str))
		{
			$scan = glob(rtrim($str,DIRECTORY_SEPARATOR).DIRECTORY_SEPARATOR.'*');
			foreach($scan as $index=>$path)
			{
				pressbackup_recursive_perform_actionFolder($path, $option);
			}
			if($option['function']=='del')
			{
				return @rmdir($str);
			}
			elseif($option['function']=='chmod')
			{
				return @chmod($str, $option['param'][0]);
			}
		}
	}

	function pressbackup_msort($type='S3', $array, $id="time")
	{
		$converted_array=array();
		if ($type == 'S3')
		{
			foreach ($array as $item)
			{
				$converted_array[]=$item;
			}
		}
		elseif (is_array($array['items']))
		{
			foreach ($array['items'] as $item)
			{
				$converted_array[]=$item['item'];
			}
		}

		$temp_array = array();
		while(count($converted_array)>0)
		{
			$lowest_id = 0;
			$index=0;
			foreach ($converted_array as $item)
			{
				if (isset($item[$id]) && $converted_array[$lowest_id][$id])
				{
					if (strcmp( $item[$id], $converted_array[$lowest_id][$id]) > 0)
					{
						$lowest_id = $index;
					}
				}
				$index++;
			}
			$temp_array[] = $converted_array[$lowest_id];
			$converted_array = array_merge(array_slice($converted_array, 0,$lowest_id), array_slice($converted_array, $lowest_id+1));
		}
		return $temp_array;
	}

	function filter_files($type='all_sites', $backup_files)
	{
		if ($type=='all_sites') {return $backup_files;}
		$blog_name =str_replace(' ', '-', strtolower(trim (get_bloginfo('name')))).'-backup';
		$filtered_array=array();
		for ($i=0; $i < count($backup_files); $i++)
		{
			$backup_from = explode('_',$backup_files[$i]['name']);
			if (rawurldecode(strtolower(trim($backup_from[0]))) == $blog_name)
			{
				$filtered_array[]= $backup_files[$i];
			}
		}
		return $filtered_array;
	}

	function pressbackup_upload_max_filesize()
	{
		if (! $filesize = ini_get('upload_max_filesize')) {
			$filesize = "5M";
		}

		if ($postsize = ini_get('post_max_size')) {
			return min(pressbackup_get_byte_size($filesize), pressbackup_get_byte_size($postsize));
		} else {
			return pressbackup_get_byte_size($filesize);
		}
	}

	function pressbackup_get_byte_size($size = 0)
	{
		if (! $size) {
			return 0;
		}

		$scan['gb'] = 1073741824; //1024 * 1024 * 1024;
		$scan['g']  = 1073741824; //1024 * 1024 * 1024;
		$scan['mb'] = 1048576;
		$scan['m']  = 1048576;
		$scan['kb'] =    1024;
		$scan['k']  =    1024;
		$scan['b']  =       1;

		foreach ($scan as $unit => $factor) {
			if (strlen($size) > strlen($unit)
			 && strtolower(substr($size, strlen($size) - strlen($unit))) == $unit) {
				return substr($size, 0, strlen($size) - strlen($unit)) * $factor;
			}
		}
		return $size;
	}

	function pressbackup_get_size_in($unit = 'm', $size= 0)
	{
		if (! $size) {
			return 0;
		}

		$scan['gb'] = 1073741824; //1024 * 1024 * 1024;
		$scan['g']  = 1073741824; //1024 * 1024 * 1024;
		$scan['mb'] = 1048576;
		$scan['m']  = 1048576;
		$scan['kb'] =    1024;
		$scan['k']  =    1024;
		$scan['b']  =       1;


		return round( $size / $scan[$unit], 2);
	}


?>
